unified logname uses into fm_username
[feisty_meow.git] / scripts / system / common_sysadmin.sh
index f6467f19af97da9b319a57453cb3440d41b844e5..a29dd6c050f84119f0ba98975c55bd70382a598c 100644 (file)
@@ -4,6 +4,10 @@
 #
 # Author: Chris Koeritz
 
+############################################################################
+
+# bind9 methods...
+
 # removes a full domain from the DNS.
 function remove_domain_file()
 {
@@ -13,7 +17,9 @@ function remove_domain_file()
   if [ -f "$domain_file" ]; then
     # don't destroy, just shuffle.
     \mv -f "$domain_file" "/tmp/$(basename ${domain_file})-old-${RANDOM}"
-    test_or_die "removing domain file: $domain_file"
+    exit_on_error "removing domain file: $domain_file"
+  else
+    echo "Did not see a domain file to remove: $domain_file"
   fi
 }
 
@@ -54,8 +60,8 @@ ${domain_name}.       IN A    ${IP_ADDRESS}
 " >"$domain_file"
 
   # our personalized configuration approach wants the real owner to own the file.
-  chown "$(logname):$(logname)" $domain_file
-  test_or_die "setting ownership on: $domain_file"
+  chown "$(fm_username):$(fm_username)" $domain_file
+  exit_on_error "setting ownership on: $domain_file"
 }
 
 # takes a zone back out of the local conf file for bind
@@ -68,48 +74,6 @@ function remove_zone_for_domain()
   # eat the zone file definition.  this will botch up badly if more text was added
   # or the zone info shrank.
   create_chomped_copy_of_file "/etc/bind/named.conf.local" "zone.*${domain_name}" 6
-
-#  \cp -f "$domain_file" "$domain_file.bkup-${RANDOM}" 
-#  test_or_die "backing up domain file: $domain_file"
-#
-#  # temp file to write to before we move file into place in bind.
-#  local new_version="/tmp/$domain_file.bkup-${RANDOM}" 
-#  \rm -f "$new_version"
-#  test_or_die "cleaning out new version of domain file from: $new_version"
-#
-#  local line
-#  local skip_count=0
-#  while read line; do
-#    # don't bother looking at the lines if we're already in skip mode.
-#    if [[ $skip_count == 0 ]]; then
-#      # find the zone for the domain.
-#      if [[ ! "$line" =~ *"zone \"${domain_name}\""* ]]; then
-#        echo "$line" >> "$new_version"
-#      else
-#        # start skipping.  we will delete this line and the next 6 lines.
-#        ((skip_count++))
-#echo first skip count is now $skip_count
-#      fi
-#    else
-#      # we're already skipping.  let's keep going until we hit the limit.
-#      ((skip_count++))
-#      if [[ $skip_count >= 6 ]]; then
-#        echo "Done skipping, and back to writing output file."
-#        skip_count=0
-#      fi
-#    fi
-#  done < "$domain_file"
-#
-##put the file back into place.
-#echo file we created looks like this:
-#filedump "$new_version"
-#
-#echo bailing
-#exit 1
-#
-#  \mv "$new_version" "$domain_file"
-#  test_or_die "moving the new version into place in: $domain_file"
-
 }
 
 # hooks up a new config file into bind's list of zones.
@@ -135,8 +99,8 @@ zone \"${domain_name}\" in {
 " >> /etc/bind/named.conf.local
 
   # keep ownership for the real user.
-  chown "$(logname):$(logname)" /etc/bind/named.conf.local
-  test_or_die "setting ownership on: /etc/bind/named.conf.local"
+  chown "$(fm_username):$(fm_username)" /etc/bind/named.conf.local
+  exit_on_error "setting ownership on: /etc/bind/named.conf.local"
 }
 
 # zaps a subdomain out of the containing domain file.
@@ -149,7 +113,6 @@ function remove_subdomain()
   local containing_domain="${old_domain#*.}"
 
   echo "removing subdomain $subdomain from containing domain $containing_domain"
-#hmmm: other functions could use that level of clarity in their logging.
 
   local domain_file="/etc/bind/${containing_domain}.conf"
   # see if config file already exists; if not, complain.
@@ -161,15 +124,14 @@ function remove_subdomain()
   fi
 
   # see if subdomain already present in config.
-  if [ ! $(grep -q "$old_domain" "$domain_file") ]; then
+  if ! grep -q "$old_domain" "$domain_file"; then
     echo "The subdomain $subdomain is already missing from the domain"
     echo "configuration file: $domain_file"
     echo "Our work is apparently done for removing it."
     return 0
   fi
 
-  create_chomped_copy_of_file "$domain_file" \
-      "${subdomain}.*${containing_domain} *IN *A *${IP_ADDRESS}" 1
+  create_chomped_copy_of_file "$domain_file" "${old_domain}" 2
 }
 
 # adds a new subdomain under a containing domain.
@@ -193,23 +155,22 @@ function add_new_subdomain()
   fi
 
   # see if subdomain already present in config.
-  if [ $(grep -q "$new_domain" "$domain_file") ]; then
+  if grep -q "$new_domain" "$domain_file"; then
     echo "The subdomain $subdomain already seems to exist in the domain"
     echo "configuration file: $domain_file"
-    echo "Please edit the config file to remove the subdomain before trying"
-    echo "to re-add the subdomain."
-    exit 1
+    echo "We are considering our work done; if you want to modify the subdomain,"
+    echo "then please call remove_domain on it first."
+    return 0
   fi
 
   # append the new subdomain into the config file.
-  echo "
-${subdomain}.${containing_domain}.    IN A    ${IP_ADDRESS}
+  echo "${subdomain}.${containing_domain}.    IN A    ${IP_ADDRESS}
         IN HINFO \"linux server\" \"${DISTRO}\"
 " >> /etc/bind/${containing_domain}.conf
 
   # keep ownership for real user.
-  chown "$(logname):$(logname)" "/etc/bind/${containing_domain}.conf"
-  test_or_die "setting ownership on: /etc/bind/${containing_domain}.conf"
+  chown "$(fm_username):$(fm_username)" "/etc/bind/${containing_domain}.conf"
+  exit_on_error "setting ownership on: /etc/bind/${containing_domain}.conf"
 }
 
 function restart_bind()
@@ -220,6 +181,192 @@ function restart_bind()
     echo "The bind service did not restart properly.  Please check the error logs."
     exit 1
   fi
-  echo DNS server restarted.
+  echo DNS service restarted.
+}
+
+############################################################################
+
+# samba server helper functions...
+
+function restart_samba
+{
+  echo restarting samba server.
+  service smbd restart
+  if [ $? -ne 0 ]; then
+    echo "The samba service did not restart properly.  Please check the error logs."
+    exit 1
+  fi
+  service nmbd restart
+  if [ $? -ne 0 ]; then
+    echo "The samba name service (nmbd) did not restart properly.  This may not always be fatal, so we are ignoring it, but you may want to check the error logs."
+  fi
+  echo samba service restarted.
+}
+
+############################################################################
+
+# apache2 methods...
+
+# removes a config file for apache given the app name and site name.
+function remove_apache_config()
+{
+  local sitename="$1"; shift
+
+  local site_config="/etc/apache2/sites-available/${sitename}.conf"
+
+  if [ -f "$site_config" ]; then
+    # don't destroy, just shuffle.
+    \mv -f "$site_config" "/tmp/$(basename ${site_config})-old-${RANDOM}"
+    exit_on_error "removing site config: $site_config"
+  else
+    echo "Did not see a site config to remove: $site_config"
+  fi
+}
+
+# this function writes out the new configuration file for the site.
+function write_apache_config()
+{
+  local appname="$1"; shift
+  local sitename="$1"; shift
+  local site_path="$1"; shift
+
+  local site_config="/etc/apache2/sites-available/${sitename}.conf"
+
+  # check if config file already exists and bail if so.
+  if [ -f "$site_config" ]; then
+    echo "The apache configuration file already exists at:"
+    echo "  $site_config"
+    echo "Since apache configuration files can get very complex, we do not want to"
+    echo "assume that this file is removable.  Calling the site addition done."
+    exit 0
+  fi
+
+  echo "Creating a new apache2 site for $sitename with config file:"
+  echo "  $site_config"
+
+  # if no path, then we default to our standard app storage location.  otherwise, we
+  # put the site where they told us to.
+  if [ -z "$site_path" ]; then
+    # path where site gets checked out, in some arcane manner, and which happens to be
+    # above the path where we put webroot (in the storage suffix, if defined).
+    local path_above="${BASE_APPLICATION_PATH}/${appname}"
+    # no slash between appname and suffix, in case suffix is empty.
+    local full_path="${path_above}${STORAGE_SUFFIX}"
+#echo really full path is $full_path
+  else
+    # we'll go with their specification for the site storage.
+    local full_path="$site_path"
+  fi
+
+  echo "
+# set up the user's web folder as an apache user web directory.
+
+# set permissions on the actual app folder.
+<Directory \"$full_path\">
+  Options +ExecCGI +Indexes +FollowSymLinks +Includes +MultiViews 
+  Require all granted
+</Directory>
+
+<VirtualHost *:80>
+    ServerName ${sitename}
+    DocumentRoot ${full_path}
+    ErrorLog \${APACHE_LOG_DIR}/${sitename}-error.log
+    CustomLog \${APACHE_LOG_DIR}/${sitename}-access.log combined
+    Include /etc/apache2/conf-library/basic-options.conf
+    Include /etc/apache2/conf-library/rewrite-enabling.conf
+</VirtualHost>
+" >"$site_config" 
+
+  chown "$(fm_username):$(fm_username)" "$site_config"
+  exit_on_error "setting ownership on: $site_config"
+}
+
+# stops apache from serving up the site.
+function disable_site()
+{
+  local sitename="$1"; shift
+  local site_config="/etc/apache2/sites-available/${sitename}.conf"
+
+  if [ ! -f "$site_config" ]; then
+    echo "The site config did not exist and could not be disabled: $site_config"
+    return 0
+  fi
+
+#hmmm: repeated pattern of hidden output file, very useful.  abstract it...
+  local outfile="$TMP/apacheout.$RANDOM"
+  a2dissite "$(basename $site_config)" &>$outfile
+  if [ $? -ne 0 ]; then
+    # an error happened, so we show the command's output at least.
+    cat $outfile
+    echo
+    echo "There was a problem disabling the apache config file in:"
+    echo "  $site_config"
+    echo "Please consult the apache error logs for more details."
+    exit 1
+  fi
+  \rm "$outfile"
+}
+
+# turns on the config file we create above for apache.
+function enable_site()
+{
+  local sitename="$1"; shift
+  local site_config="/etc/apache2/sites-available/${sitename}.conf"
+
+  local outfile="$TMP/apacheout.$RANDOM"
+  a2ensite "$(basename $site_config)" &>$outfile
+  if [ $? -ne 0 ]; then
+    # an error happened, so we show the command's output at least.
+    cat $outfile
+    echo
+    echo "There was a problem enabling the apache config file in:"
+    echo "  $site_config"
+    echo "Please consult the apache error logs for more details."
+    exit 1
+  fi
+  \rm "$outfile"
+}
+
+# restarts the apache2 service.
+function restart_apache()
+{
+  service apache2 restart
+  if [ $? -ne 0 ]; then
+    echo "There was a problem restarting the apache2 service."
+    echo "Please consult the apache error logs for more details."
+    exit 1
+  fi
+  echo Apache2 service restarted.
 }
 
+# sets up the serverpilot storage location for a user hosted web site.
+function maybe_create_site_storage()
+{
+  local our_app="$1"; shift
+  # make sure the path for storage this app exists for the user.
+  local full_path="$BASE_APPLICATION_PATH/$our_app"
+  if [ ! -d "$full_path" ]; then
+    mkdir -p $full_path
+    exit_on_error "The app storage path could not be created.\n  Path in question is: $full_path"
+  fi
+
+  # now give the web server some access to the folder.  this is crucial since the folders
+  # can be hosted in any user folder, and the group permissions will not necessarily be correct already.
+  local chow_path="$full_path"
+  # only the first chmod is recursive; the rest just apply to the specific folder of interest.
+  chmod -R g+rx "$chow_path"
+  # walk backwards up the path and fix perms.
+  while [[ $chow_path != $HOME ]]; do
+#echo chow path is now $chow_path
+    chmod g+rx "$chow_path"
+    exit_on_error "Failed to add group permissions on the path: $chow_path"
+    # reassert the user's ownership of any directories we might have just created.
+    chown "$(fm_username):$(fm_username)" "$chow_path"
+    exit_on_error "changing ownership to user failed on the path: $chow_path"
+    chow_path="$(dirname "$chow_path")"
+  done
+}
+
+############################################################################
+
+